﻿------------------------------
--      Are you local?      --
------------------------------

local boss = BB["Drakos the Interrogator"]

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	cmd = "Drakos",
	magicpull = "Magic Pull",
	magicpull_desc = "Announce Magic Pull",
	magicpull_message = "Casting Magic Pull",
}

end )

L:RegisterTranslations("deDE", function() return {
	cmd = "Drakos",
	magicpull = "Magische Anziehung",
	magicpull_desc = "Magische Anziehung ankündigen",
	magicpull_message = "Zaubert Magische Anziehung",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	cmd = "Drakos",
	magicpull = "Traction magique",
	magicpull_desc = "Prévient quand la Traction magique est incantée.",
	magicpull_message = "Traction magique en incantation",
}

end )

L:RegisterTranslations("koKR", function() return {
	cmd = "드라코스",
	magicpull = "마법 인력",
	magicpull_desc = "마법 인력을 알립니다.",
	magicpull_message = "마법 인력 시전",
}

end )

L:RegisterTranslations("ruRU", function() return {
	cmd = "Drakos",
	magicpull = "Магическое притяжение",
	magicpull_desc = "Оповещать о магическом притяжении",
	magicpull_message = "Применяется магическое притяжение",
}

end )

L:RegisterTranslations("zhCN", function() return {
	magicpull = "魔法牵引",
	magicpull_desc = "当施放魔法牵引时发出警报。",
	magicpull_message = "正在施放 魔法牵引！",
}

end )

L:RegisterTranslations("zhTW", function() return {
	cmd = "德拉高斯",
	magicpull = "魔法拖曳",
	magicpull_desc = "當施放魔法拖曳時發出警報。",
	magicpull_message = "正在施放 魔法拖曳！",
}

end )

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = BigWigs:NewModule(boss)
mod.partyContent = true
mod.otherMenu = "Coldarra"
mod.zonename = BZ["The Oculus"]
mod.enabletrigger = {boss} 
mod.guid = 27654
mod.toggleoptions = {"magicpull", "bosskill"}
mod.revision = tonumber(("$Revision: 542 $"):sub(12, -3))

------------------------------
--      Initialization      --
------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_CAST_START", "MagicPull", 51336)
	self:AddCombatListener("UNIT_DIED", "BossDeath")
end

------------------------------
--      Event Handlers      --
------------------------------

function mod:MagicPull(_, spellId)
	if self.db.profile.magicpull then
		self:IfMessage(L["magicpull_message"], "Important", spellId)
	end
end
