﻿----------------------------------
--      Module Declaration      --
----------------------------------

local boss = BB["Mal'Ganis"]
local mod = BigWigs:New(boss, tonumber(("$Revision: 543 $"):sub(12, -3)))
if not mod then return end
mod.partyContent = true
mod.otherMenu = "Caverns of Time"
mod.zonename = BZ["The Culling of Stratholme"]
mod.enabletrigger = boss 
mod.guid = 26533
mod.toggleoptions = {"sleep", "sleepBar", -1, "vampTouch", "vampTouchBar", "bosskill"}

----------------------------------
--        Are you local?        --
----------------------------------

local sleepDuration

----------------------------------
--         Localization         --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BigWigs"..boss)

L:RegisterTranslations("enUS", function() return {
	cmd = "Mal'Ganis",
	sleep = "Sleep",
	sleepBar = "Sleep Bar",
	sleepBar_desc = "Show a bar for the duration of the sleep.",
	sleep_desc = "Warn for who is put to sleep.",
	sleep_message = "Sleep: %s",
	vampTouch = "Vampiric Touch",
	vampTouchBar = "Vampiric Touch Bar",
	vampTouchBar_desc = "Display a bar for the duration of Mal'Ganis Vampiric Touch.",
	vampTouch_desc = "Warn when Mal'Ganis gains Vampiric Touch.",
	vampTouch_message = "Mal'Ganis gains Vampiric Touch",
}

end )

L:RegisterTranslations("deDE", function() return {
	cmd = "Mal'Ganis",
	sleep = "Schlaf",
	sleepBar = "Leiste: Schlaf",
	sleepBar_desc = "Eine Leiste für die Dauer des Schlafes anzeigen.",
	sleep_desc = "Warnen, wer eingeschläfert wird.",
	sleep_message = "Schlaf : %s",
	vampTouch = "Vampirberührung",
	vampTouchBar = "Leiste: Vampirberührung",
	vampTouchBar_desc = "Eine Leiste für die Dauer von Mal'Ganis' Vampirberührung anzeigen.",
	vampTouch_desc = "Warnen, wenn Mal'Ganis Vampirberührung bekommt.",
	vampTouch_message = "Mal'Ganis bekommt Vampirberührung",
}

end )

L:RegisterTranslations("esES", function() return {
}

end )

L:RegisterTranslations("esMX", function() return {
}

end )

L:RegisterTranslations("frFR", function() return {
	cmd = "Mal'Ganis",
	sleep = "Sommeil",
	sleepBar = "Sommeil - Barre",
	sleepBar_desc = "Affiche une barre indiquant la durée du Sommeil en cours.",
	sleep_desc = "Prévient quand un joueur subit les effets de Sommeil.",
	sleep_message = "Sommeil : %s",
	vampTouch = "Toucher vampirique",
	vampTouchBar = "Toucher vampirique - Barre",
	vampTouchBar_desc = "Affiche une barre indiquant la durée du Toucher vampirique en cours.",
	vampTouch_desc = "Prévient quand Mal'Ganis gagne Toucher vampirique.",
	vampTouch_message = "Mal'Ganis gagne Toucher vampirique",
}

end )

L:RegisterTranslations("koKR", function() return {
	cmd = "말가니스",
	sleep = "수면",
	sleepBar = "수면 바",
	sleepBar_desc = "수면이 지속되는 바를 표시합니다.",
	sleep_desc = "수면에 걸린 플레이어를 알립니다.",
	sleep_message = "수면: %s",
	vampTouch = "흡혈의 손길",
	vampTouchBar = "흡혈의 손길 바",
	vampTouchBar_desc = "말가니스의 흡혈의 손길이 지속되는 바를 표시합니다.",
	vampTouch_desc = "말가니스의 흡혈의 손길 획득을 알립니다.",
	vampTouch_message = "말가니스 흡혈의 손길 획득",
}

end )

L:RegisterTranslations("ruRU", function() return {
	cmd = "Mal'Ganis",
	sleep = "Сон",
	sleepBar = "Полоса сна",
	sleepBar_desc = "Отображать полосу продолжительности сна.",
	sleep_desc = "Сообщать об усыпленных игроках.",
	sleep_message = "Сон: %s",
	vampTouch = "Прикосновение вампира",
	vampTouchBar = "Полоса прикосновения вампира",
	vampTouchBar_desc = "Отображать полосу продолжительности прикосновения вампира Мал'Ганиса.",
	vampTouch_desc = "Сообщать когда Мал'Ганис получает Прикосновение вампира.",
	vampTouch_message = "Мал'Ганис получил Прикосновение вампира!",
}

end )

L:RegisterTranslations("zhCN", function() return {
	sleep = "沉睡",
	sleepBar = "沉睡计时条",
	sleepBar_desc = "当沉睡持续时显示计时条。",
	sleep_desc = "当玩家中了沉睡时发出警报。",
	sleep_message = "沉睡：>%s<！",
	vampTouch = "吸血鬼之触",
	vampTouchBar = "吸血鬼之触计时条",
	vampTouchBar_desc = "当玛尔加尼斯的吸血鬼之触持续时显示计时条。",
	vampTouch_desc = "当玛尔加尼斯获得吸血鬼之触时发出警报。",
	vampTouch_message = "玛尔加尼斯获得：>吸血鬼之触<！",
}

end )

L:RegisterTranslations("zhTW", function() return {
	cmd = "瑪爾加尼斯",
	sleep = "催眠術",
	sleepBar = "催眠術計時條",
	sleepBar_desc = "當催眠術持續時顯示計時條。",
	sleep_desc = "當玩家中了催眠術時發出警報。",
	sleep_message = "催眠術：>%s<！",
	vampTouch = "吸血之觸",
	vampTouchBar = "吸血之觸計時條",
	vampTouchBar_desc = "當瑪爾加尼斯的吸血之觸持續時顯示計時條。",
	vampTouch_desc = "當瑪爾加尼斯獲得吸血之觸時發出警報。",
	vampTouch_message = "瑪爾加尼斯獲得：>吸血之觸<！",
}

end )

----------------------------------
--        Initialization        --
----------------------------------

function mod:OnEnable()
	self:AddCombatListener("SPELL_AURA_APPLIED", "Sleep", 52721, 58849)
	self:AddCombatListener("SPELL_AURA_REMOVED", "SleepRemove", 52721, 58849)	
	self:AddCombatListener("SPELL_AURA_APPLIED", "VampTouch", 52723)
	self:AddCombatListener("SPELL_AURA_REMOVED", "VampTouchRemove", 52723)
	self:AddCombatListener("UNIT_DIED", "BossDeath")
end

----------------------------------
--        Event Handlers        --
----------------------------------

function mod:Sleep(player, spellId)
	if self.db.profile.sleep then
		self:IfMessage(L["sleep_message"]:format(player), "Important", spellId)
	end
	if self.db.profile.sleepBar then
		if spellId == 58849 then sleepDuration = 8 else sleepDuration = 10 end
		self:Bar(L["sleep_message"]:format(player), sleepDuration, spellId)
	end
end

function mod:SleepRemove(player)
	if self.db.profile.sleepBar then
		self:TriggerEvent("BigWigs_StopBar", self, L["sleep_message"]:format(player))
	end
end

function mod:VampTouch(target, spellId, _, _, spellName)
	if target ~= boss then return end
	if self.db.profile.vampTouch then
		self:IfMessage(L["vampTouch_message"], "Important", spellId)
	end
	if self.db.profile.vampTouchBar then
		self:Bar(spellName, 30, spellId)
	end
end

function mod:VampTouchRemove(target, _, _, _, spellName)
	if target ~= boss then return end
	if self.db.profile.vampTouchBar then
		self:TriggerEvent("BigWigs_StopBar", self, spellName)
	end
end
